/*
 * Copyright (C) 2007 Loren Merritt <lorenm@u.washington.edu>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 */

#include "common.h"

// Compile a second copy of the bitstream functions. This one doesn't actually
// write a bitstream, but just counts how many bits would be used.

#define xlsc_macroblock_write xlsc_macroblock_size
#define put_rac(c,p,b) h->out.rd_bits += size_rac(p,b)
#define put_rac_bypass(c,b) h->out.rd_bits += 256;
#define RDO_SKIP_BS

#include "write.c"

int xlsc_rd_cost( xlsc_t *h )
{
    xlsc_macroblock_encode( h );
    uint32_t ssd = h->dsp.ssd( h->mb.fenc, h->mb.fdec, FENC_STRIDE );
    h->out.rd_bits = 0;
    xlsc_macroblock_size( h );
    return ssd + (((uint64_t)h->out.rd_bits * h->lambda2 + (1<<13)) >> 14);
}

